using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_lock")]
    public class SecurityLockEntity : EntityBase<SecurityLockEntityKey>
    {

    public SecurityLockEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Column("entity_name")]
    public string EntityName  { get; set; }
    [Column("pkey_id")]
    public string PkeyId  { get; set; }
    [Column("locked_by_actor")]
    public string LockedByActor  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string ENTITY_NAME = "EntityName";
    public const string PKEY_ID = "PkeyId";
    public const string LOCKED_BY_ACTOR = "LockedByActor";

    public const string DB_NAME_SECURITY_LOCK = "security_lock";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,entity_name,pkey_id,locked_by_actor";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_ENTITY_NAME = "entity_name";
    public const string DB_PKEY_ID = "pkey_id";
    public const string DB_LOCKED_BY_ACTOR = "locked_by_actor";


    public static SecurityLockEntity GetInstance()
    {
        return new SecurityLockEntity();
    }

    public virtual void CopyFrom(SecurityLockEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityLockEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.EntityName =  source.EntityName;
        this.PkeyId =  source.PkeyId;
        this.LockedByActor =  source.LockedByActor;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_LOCK}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_LOCK}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_ENTITY_NAME ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_LOCK}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityLockEntity Clone()
    {
        SecurityLockEntity result = new SecurityLockEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
